#include <stdio.h>
#include <stdlib.h>
#include "stablo.h"

void greska(char *s) {
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int v) {
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("malloc");
	novi->vrednost = v;
	novi->levo = NULL;
	novi->desno = NULL;
	return novi;
}

cvor* dodaj_u_stablo(cvor *koren, int v) {
	if(koren == NULL)
		return kreiraj_cvor(v);
	else {
		if(v < koren->vrednost)
			koren->levo = 
				dodaj_u_stablo(koren->levo, v);
		else
			koren->desno = 
				dodaj_u_stablo(koren->desno, v);
		return koren;
	}
}

cvor* ucitaj_stablo() {
	//UVEK PRAZNO STABLO ILI PRAZNU LISTU
	//INICIJALIZOVATI NA NULL
	cvor *koren = NULL;
	int x;
	while(1) {
		scanf("%d", &x);
		if(x == 0)
			break;
		koren = dodaj_u_stablo(koren, x);
	}
	return koren;
}

void ispis_LKD(cvor *koren) {
	if(koren == NULL)
		return;
	ispis_LKD(koren->levo);
	printf("%d ", koren->vrednost);
	ispis_LKD(koren->desno);
}

void ispis_KLD(cvor *koren) {
	if(koren == NULL)
		return;
	printf("%d ", koren->vrednost);
	ispis_KLD(koren->levo);
	ispis_KLD(koren->desno);
}

void ispis_LDK(cvor *koren) {
	if(koren == NULL)
		return;
	ispis_LDK(koren->levo);
	ispis_LDK(koren->desno);
	printf("%d ", koren->vrednost);
}

cvor* oslobodi(cvor *koren) {
	if(koren == NULL)
		return NULL;
	oslobodi(koren->levo);
	oslobodi(koren->desno);
	free(koren);
	return NULL;
}

//pretraga moze da vrati cvor gde je pronadjena vrednost
//ili tacno, netacno da li je pronadjena vrednost

cvor* pretraga(cvor *koren, int vrednost) {
	if(koren == NULL)
		//nismo pronasli nista
		return NULL;
	
	if(koren->vrednost == vrednost)
		return koren;
	
	if (vrednost < koren->vrednost)
		//pretrazujemo samo levo podstablo
		return pretraga(koren->levo, vrednost);
	else
		//pretrazujemo samo desno podstablo
		return pretraga(koren->desno, vrednost);
}

int broj_cvorova(cvor *koren) {
	if(koren == NULL)
		return 0;
	else
		return 1 +
			broj_cvorova(koren->levo) + 
			broj_cvorova(koren->desno);
}

int  broj_listova(cvor *koren) {
	//da li je prazno stablo
	if(koren == NULL)
		return 0;
	//da li je list
	if(koren->levo == NULL && koren->desno == NULL)
		return 1;
	//rekurzivni pozivi
	return broj_listova(koren->levo) 
		+ broj_listova(koren->desno);
}

int suma_cvorova(cvor *koren) {
	if(koren == NULL)
		return 0;
	return koren->vrednost +
		suma_cvorova(koren->levo) +
		suma_cvorova(koren->desno);
}

int suma_listova(cvor *koren) {
	if(koren == NULL)
		return 0;
	if(koren->levo == NULL && koren->desno == NULL)
		return koren->vrednost;
	return suma_listova(koren->levo) +
		suma_listova(koren->desno);
}

void ispis_listova(cvor *koren) {
	if(koren == NULL)
		return;
	if(koren->levo == NULL && koren->desno == NULL)
		printf("%d ", koren->vrednost);
	ispis_listova(koren->levo);
	ispis_listova(koren->desno);
}

//dubina je najduzi put od korena do lista
int dubina(cvor *koren) {
	if(koren == NULL)
		return 0;
	
	int l_dubina = dubina(koren->levo);
	int d_dubina = dubina(koren->desno);
	
	return l_dubina > d_dubina ?
		l_dubina + 1 :
		d_dubina + 1;
}

int max_neuredjeno_stablo(cvor *koren) {
	if(koren == NULL)
		return 0;
	int ml = max_neuredjeno_stablo(koren->levo);
	int md = max_neuredjeno_stablo(koren->desno);
	int mp = ml > md ? ml : md;
	return koren->vrednost > mp ? 
		koren->vrednost :
		mp;
}

int max_uredjeno_stablo(cvor *koren) {
	if(koren == NULL)
		return 0;
	while(koren->desno != NULL)
		koren = koren->desno;
	return koren->vrednost;
}

/* PRAVIMO BIBLIOTEKU PA KOMENTARISEMO CEO MAIN
int main()
{
	cvor *s = ucitaj_stablo();
	
	//test ispis:
	//ispis_KLD(s);
	//printf("\n");
	
	//ispis_LKD(s);
	//printf("\n");
	
	//ispis_LDK(s);
	//printf("\n");
	
	//test pretraga:
	//int x;
	//scanf("%d", &x);
	//cvor *rez = pretraga(s, x);
	//if(rez == NULL)
	//	printf("nije pronadjeno");
	//else
	//	printf("pronadjeno");
	
	printf("broj cvorova: %d\n", broj_cvorova(s));
	printf("broj listova: %d\n", broj_listova(s));
	printf("suma cvorova: %d\n", suma_cvorova(s));
	printf("suma listova: %d\n", suma_listova(s));
	
	printf("Listovi:\n");
	ispis_listova(s);
	printf("\n");
	
	printf("dubina: %d\n", dubina(s));
	printf("max neuredjeno: %d\n", max_neuredjeno_stablo(s));
	printf("max uredjeno: %d\n", max_uredjeno_stablo(s));
	
	s = oslobodi(s);
}*/